.686P
.model flat, stdcall
option casemap:none

    include \masm32\include\windows.inc

    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\advapi32.inc
    
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\advapi32.lib

ASSUME fs:nothing

; ###################################################################
; SEGMENT PAGE
; ###################################################################

YoLeJedi segment page private 'CODE'

; ###################################################################
; CODE
; ###################################################################

include macros.asm
include const.asm
include struct.asm
include reg_const.asm

include create_ntdll_import.asm
include seh_report_error.asm
include data.asm
include cherche_table.asm 
include get_ntoskrnl_info.asm
include change_dacl.asm
include restore_dacl.asm
include mappe.asm
include demappe.asm
include GetNtoskrnlProcAddress.asm
include virtual2physical.asm
include restore_system.asm

include hook_filter.asm
include code_table_system.asm

include fonctions\fonctions.asm

start:
; int 3
    pushad
    Create_SEH  SEH
    mov eax,dword ptr [esp+_pushad+(4*4)]     ; reason
    cmp eax,DLL_PROCESS_ATTACH
    je mappage_dll
    cmp eax,DLL_PROCESS_DETACH
    je demappage_dll
sortie :
    Restore_SEH 0
    mov dword ptr [esp+_eax],eax
    popad 
    ret 0Ch 

; *******************************************************************
; *                          MAPPAGE DLL                            *
; *******************************************************************

mappage_dll :

    push offset critical_section
    call InitializeCriticalSection
 
    push offset critical_section
    call EnterCriticalSection 

    mov word ptr [ss_ring3],ss
    mov word ptr [cs_ring3],cs
    mov word ptr [fs_ring3],fs

    pushfd
    pop eax
    bts eax,bit_IF    ; active interruption
    and eax, not (_DF or _TF or _OF or _SF or _ZF or _AF or _PF or _CF or _RF or _NT)
    mov dword ptr [eflag_ring3], eax

    mov ax,ds
    and ax,00000100b        ; regarde le bit TI du registre de segment DS
                            ; TI=1 -> LDT -> Win9x
                            ; TI=0 -> GDT -> WinNt
    jne sortie_mappage_dll  ; Win9x

    call create_ntdll_import

    call cherche_table
    cmp dword ptr [table_n],-1
    jne sortie_mappage_dll

;********************************************************************

    mov eax,Taille_hook_filter
    cmp eax, 080h                  ; vrifie si le code filtre entre dans l'image_dos_header de ntoskrnl.exe
    ja sortie_erreur_mappage_dll

; *******************************************************************

    call change_security
Verif_egal eax,STATUS_SUCCESS,"Les proprits de la DACL n'ont pas pu tre modifies ?!?!"

; ------------------------------------------------------------------------ 

    call get_ntoskrnl_info
Verif_egal eax,STATUS_SUCCESS,"Les infos sur ntoskrnl.exe n'ont pas pu tre trouves ?!?!"

; ######################################################################## 

    mov eax, offset ntoskrnl_physical_address
    mov ebx, 1000h                              ; size
    call mappe
Verif_registre_different eax,0,"le header de ntoskrnl.exe n'a pas pu tre mapp en mmoire utilisateur ?!?!"

    mov dword ptr [handle_map_ntoskrnl], eax
    add eax, dword ptr [page_ntoskrnl_offset]
Verif_egal word ptr [eax],"ZM","Le Header de ntoskrnl.exe n'est pas valide ?!?!"

    mov ebx, dword ptr [eax+03Ch]
    cmp ebx, 080h 
    jae @F
Verif_egal esp,0,"Le Header de ntoskrnl.exe n'a pas assez de place ?!?!"    ; juste pour afficher le message 
@@ :
Verif_egal word ptr [eax+ebx],"EP","Le Header de ntoskrnl.exe n'est pas valide ?!?!"

; ---------------  sauve ntoskrnl data header crases --------------------

    mov esi, eax
    mov edi, offset ntoskrnl_original_header
    xor ecx,ecx
    mov cl, 020h
    cld
    rep movsd

; --------  Place le code hook_filter dans le header de ntoskrnl ---------
    mov edi, eax
    mov esi, offset hook_filter
    mov ecx, Taille_hook_filter
    xor ebx ,ebx
    cld
boucle_place_code_hook :    
    lodsb
    cmp ebx, 03Ch
    jb @F
    cmp ebx, 03Fh
    ja @F
    mov al, byte ptr [edi]
@@ :
    stosb
    inc ebx
    loop boucle_place_code_hook

; ######################################################################## 

    mov eax, offset NtCreateFile_physical_address
    mov ebx, 2000h                              ; size
    call mappe
Verif_registre_different eax,0,"la page de NtCreateFile n'a pas pu tre mapp en mmoire utilisateur ?!?!"
    mov dword ptr [handle_map_NtCreateFile], eax

; ---------------  vrifie et sauve le code cras de NtCreateFile --------------------
;int 3
    xor ecx,ecx
    mov cl, 8
    add eax, dword ptr [page_NtCreateFile_offset]
@@ :    
    mov ebx, dword ptr [eax]
    and ebx, 00FFFFFFh
    cmp ebx, 00EC8B55h          ; vrif :   push ebp
    je @F                       ;           mov ebp,esp
    inc eax
    loop @B 
Verif_egal esp,0,"Le code de NtCreaeFIle n'a pas pu tre identifi ?!?!"    ; juste pour afficher le message
                                                                                  
@@ :
    mov ebx, eax
    sub ebx, dword ptr [handle_map_NtCreateFile]
    mov dword ptr [page_NtCreateFile_offset],ebx    ; devient l'offset de push ebp

    inc eax                                         ; se place sur le "mov ebp,esp"

    mov esi, eax
    mov edi, offset NtCreateFile_original_code
    xor ecx,ecx
    inc ecx
    inc ecx
    cld
    rep movsd                                       ; sauve le code original de ntoskrnl!NtCreateFile

; --------------------------  Hook NtCreateFile ----------------------------
    mov eax, dword ptr [IBS_ntoskrnl]
    add eax,2                       ; eax pointe sur le code hook_filter

    sub esp, (2*4)

    mov word  ptr [esp],   0C08Bh   ;   mov eax,eax        ; juste pour pouvoir dhooker proprement avec "jmp $"   
    mov byte  ptr [esp+2], 068h     ;   push
    mov dword ptr [esp+3], eax      ;   hook_filter 
    mov byte  ptr [esp+7], 0C3h     ;   ret
    
    fild qword ptr [esp]            ; place la portion de code qui doit 
                                    ; hooker NtCreateFile sur la pile du FPU             
    fwait
    add esp, (2*4)

    mov edi, dword ptr [handle_map_NtCreateFile]
    add edi, dword ptr [page_NtCreateFile_offset]
    inc edi                                         ; se place sur le "mov ebp,esp"
        
    mov word ptr [edi], 0FEEBh       ; remplace le "mov ebp,esp" par "jmp $".
                                     ; ceci bloque les process qui veulent utiliser
                                     ; NtCreateFile
                                         
    SLEEP 100                        ; attend 100 millisecondes afin de laisser avancer
                                     ; les ventuels process dont l'eip se trouve
                                     ; juste aprs le "mov ebp,esp".

    fistp qword ptr [edi]            ; Hook NtCreateFile par crasement de code.
                                     ; "fistp" permet d'craser le code sur 64bits
                                     ; grace  une seule instruction assembleur.
    fwait   
    
; ######################################################################## 
 
; ------------------------ active le code ring0 -----------------------------
    sub esp, (0Bh-3)*4
    push Taille_data_code_system    ; taille en octets
    push offset create_new_table    ; zone cible
    push 'JEDI'                     ; mot de passe
    
    call dword ptr [@NtCreateFile]            ; NtCreateFile ne sert qu'a activer le code ring0                                     ; Les paramtres ont t rappropris

; --------------------------  Dehook NtCreateFile ---------------------------

    push dword ptr [NtCreateFile_original_code+4]
    push dword ptr [NtCreateFile_original_code] 
       
    fild qword ptr [esp]            ; place la portion du code original
                                    ; de NtCreateFile sur la pile du FPU                
    fwait
    add esp, (2*4)

    mov edi, dword ptr [handle_map_NtCreateFile]
    add edi, dword ptr [page_NtCreateFile_offset]
    inc edi                                         ; se place sur le "mov eax,eax"


    mov word ptr [edi], 0FEEBh       ; remplace le "mov eax,eax" par "jmp $".
                                     ; ceci bloque les process qui veulent utiliser
                                     ; NtCreateFile

    SLEEP 100                        ; attend 100 millisecondes afin de laisser avancer
                                     ; les ventuels process dont l'eip se trouve
                                     ; juste aprs le "mov eax,eax".    

    fistp qword ptr [edi]            ; Dehook NtCreateFile par crasement de code.
                                     ; "fistp" permet d'craser le code avec une
                                     ; seule instruction assembleur
    fwait

; --------------- restaure le header de noskrnl ---------------------

    mov edi, dword ptr [handle_map_ntoskrnl]
    add edi, dword ptr [page_ntoskrnl_offset]
    mov esi, offset ntoskrnl_original_header
    xor ecx,ecx
    mov cl, 020h
    cld
    rep movsd
; ------------------ restaure le system -----------------------

    call restore_system

; ----------- vrifie si la table perso des services system est active -----------
   call cherche_table
Verif_registre_different dword ptr [table_n],-1,"La nouvelle Table NtCall n'a pas t trouve ?!?!"

sortie_mappage_dll :

    push offset critical_section
    call LeaveCriticalSection  

    push offset critical_section
    call DeleteCriticalSection 

    xor eax,eax
    inc eax         ; TRUE
    jmp sortie

sortie_erreur_mappage_dll :

    mov ax,ds
    and ax,00000100b        ; regarde le bit TI du registre de segment DS
                            ; TI=1 -> LDT -> Win9x
                            ; TI=0 -> GDT -> WinNt
    jne @F                  ; Win9x

    call restore_system
@@ :
    push offset critical_section
    call LeaveCriticalSection  

    push offset critical_section
    call DeleteCriticalSection 

    xor eax,eax     ; FALSE
    jmp sortie

demappage_dll :
    jmp sortie


; *******************************************************************
; *                             SEH                                 *
; *******************************************************************

SEH :
    pushad
    lea edi,[esp+04+_pushad]
  ASSUME edi: ptr POINTEURS_EXCEPTION_LIEE

    mov ebp,[edi].Err_Struct
    mov esi,[edi].ExceptionRecord
    mov edi,[edi].ContextRecord

ASSUME edi: ptr CONTEXT 
ASSUME esi: ptr EXCEPTION_RECORD

    mov eax, dword ptr [edi].regEip
    cmp word ptr [eax], 0D00Fh          ; erreur fatal
    je seh_error_procedure

    mov eax, dword ptr [edi].regEip
    cmp word ptr [eax], 0B90Fh          ; erreur ignore
    jne sortie_Report_ExceptionContinueExecution

    add dword ptr [edi].regEip, 2
    jmp seh_error_procedure

seh_error_procedure :
    
    push 010h
    push offset titre_erreur
    push [edi].regEax
    push 0
    call MessageBoxA 

    mov eax, dword ptr [edi].regEip
    cmp word ptr [eax], 0D00Fh
    jne sortie_ExceptionContinueExecution

    mov ax,ds
    and ax,00000100b                            
    jne sortie_Report_ExceptionContinueExecution  ; Win9x   
     
    push 010h
    push offset titre_erreur
    call @F
    db "Une fonction vient de renvoyer un message d'erreur.",0Dh,0Ah
    db "jedi_land.dll fonctionne uniquement en mode administrateur.",0Dh,0Ah
    db "Veuillez vrifier que vous tes bien dans une session administrateur.",0Dh,0Ah
    db 0
@@ :
    push 0
    call MessageBoxA 
    jmp sortie_avec_eip_sortie_erreur_mappage_dll

sortie_Report_ExceptionContinueExecution :

    push edi            ; CONTEXT 
    push esi            ; EXCEPTION_RECORD
    call rapport_erreur
    jmp sortie_avec_eip_sortie_erreur_mappage_dll

sortie_avec_eip_sortie_erreur_mappage_dll :

    mov [edi].regEip, sortie_erreur_mappage_dll
    mov [edi].regEsp, ebp
    jmp sortie_ExceptionContinueExecution

sortie_ExceptionContinueExecution :
    popad
    mov eax,ExceptionContinueExecution
    ret
        
YoLeJedi ends
end start
































